#!/usr/local/bin/perl

#==================================================================
$g_name = "WwwLounge Ver2.17";
#
# Copyright (C) 1997-2020 mX http://www.tohoho-web.com/
#
# @l/l/p/p킸AgpEEĔzz\łB
#==================================================================

# 
# 1999/05/23 2.00 
# 1999/05/23 2.01 ssƂĕ\ȂoOC
# 1999/05/30 2.02 utimeR}hɃpX[h`FbNǉ
# 1999/05/30 2.03 bZ[W̉s폜悤ɏC
# 1999/05/30 2.04 u>vɉāuvpƌȂ悤ɂ
# 1999/05/30 2.05 ^CgΏۂɂȂ悤ɏC
# 1999/06/06 2.06 bNt@C̃p[~bV7550755ɏC
# 1999/06/06 2.06 p̐FύX
# 1999/10/03 2.07 ăbNt@CĂ܂ƂoOC
# 2000/03/20 2.08 [AhX̌``FbN
# 2000/05/07 2.09 Perl4Ή
# 2000/10/14 2.10 NetscapẽT[o[ɑΉ
# 2000/10/29 2.11 [AhXsɋt@CłC
# 2001/04/30 2.12 ZLeBz[Ή
# 2001/05/01 2.13 
# 2001/09/10 2.14 \[g܂Ȃ̏C
# 2001/09/10 2.15 
# 2005/03/07 2.16 ZLeBz[Ή
# 2020/01/05 2.17 ϔ\@\Aʕ\@\ǉ

# R[hϊCu
require "jcode.pl";

# {̂߂̊ϐ
$ENV{'TZ'} = "JST-9";

# O[oϐ
$g_dir = "wwwlng";
@g_wdays = ( "", "", "", "", "", "", "y" );
$g_return_url = "";
$g_default_number = 50;
$g_lockdir = "../lock";
$g_lockfile = "$g_lockdir/wwwlng.loc";
$g_sendmail = '/usr/lib/sendmail';	# [MR}h
$g_show_questioner = 0;
$g_passwd = "";
$g_search_log = "search.txt";
$g_unsolved = 0;
$g_target = "_self";     # _blank:ʉʁA_self:

#
# C[`
#
{
    # JgfBNg̈ړ
    chdir($g_dir);

    # tH[f[^ǂݍ
    if (!&readParam()) {
        &showErrorPage("f[^̓ǂݍ݂Ɏs܂B");
        exit(0);
    }

    # ꂼ̃y[W\ɃWv
    if ($#ARGV == -1) {
        &showTopPage($g_default_number);	# gbv
    } elsif ($ARGV[0] eq "dir") {
        &showDirPage($ARGV[1]);			# gsbNꗗ
    } elsif ($ARGV[0] eq "list") {
        &showTopicListByDays($ARGV[1], $ARGV[2]);		# gsbNꗗ
    } elsif ($ARGV[0] eq "print") {
        &showTopicPage($ARGV[1]);		# gsbN\
    } elsif ($ARGV[0] eq "showall") {
        &showLatelyPage($ARGV[1], $ARGV[2]);		# S\
    } elsif ($ARGV[0] eq "new") {
        &showNewTopicPage();			# VKgsbN
    } elsif ($ARGV[0] eq "search") {
        &showSearchPage();			# 
    } elsif ($ARGV[0] eq "test") {
        &showTestPage();			# Ȑff
    } elsif ($ARGV[0] eq "new2") {
        &appendTopic();				# gsbNǉ
    } elsif ($ARGV[0] eq "append") {
        &appendMessage($ARGV[1], 1);		# ǉ
    } elsif ($ARGV[0] eq "delete") {
        shift(@ARGV);
        &deleteTopic(@ARGV);			# gsbN폜
    } elsif ($ARGV[0] eq "utime") {
        shift(@ARGV);
        &utimeTopic(@ARGV);			# t@C̍XV킹
    } else {
        &showErrorPage("URL̎w肪Ă܂B");
    }

    exit(0);
}

#
# gbvy[W
#
sub showTopPage #($num)
{
    local($num) = @_;
    local($dir, @dirs, $file, @files);

    &printHeader("EW(ŋߍXVꂽgsbN)");
    if ($g_return_url) {
        print "<A HREF=\"$g_return_url\">[߂]</A>\n";
    }
    print "<A HREF=\"wwwlng.htm\">[gp̒]</A>\n";
    print "<A HREF=\"wwwlng.cgi?new\">[VK]</A>\n";
    print "<A HREF=\"#folders\">[ߋ̃tH_ꗗ]</A>\n";
    print "<HR>\n";

    #print "<HR>\n";
    #print "<FONT COLOR=red>݁ÃEW͎^płB";
    #print "^pɏ܂ꂽf[^ׂ͂ď܂̂ŁA";
    #print "͂́AeXgf[^݁Â͂";
    #print "肢܂B</FONT>\n";
    #print "<HR>\n";

    # ŋߍXVꂽgsbN̈ꗗ𓾂
    if (!opendir(DIR, ".")) {
        &showErrorPage("tH_ǂݏo܂B");
        exit(0);
    }
    while ($dir = readdir(DIR)) {
        if ($dir =~ /^\./) { next; }
        if (! -d $dir) { next; }
        push(@dirs, $dir);
        opendir(DIR2, $dir) || next;
        while ($file = readdir(DIR2)) {
            if ($file =~ /^\./) { next; }
            if (! -f "$dir/$file") { next; }
            $mtime = (stat("$dir/$file"))[9];
            ($sec, $min, $hour, $mday, $mon, $year) = localtime($mtime);
            $timestr = sprintf("%04d%02d%02d%02d%02d%02d",
                $year + 1900, $mon + 1, $mday, $hour, $min, $sec);
            push(@files, "$timestr $dir/$file");
        }
        closedir(DIR2);
    }
    closedir(DIR);
    @dirs = sort(@dirs);
    @files = sort { $b cmp $a } @files;
    splice(@files, $num);

    # ŋߍXVꂽgsbNꗗ
    print "<P>\n";
    &printTopicList(@files);

    # tH_ꗗ
    if ($#dirs >= 0) {
        print "<P>\n";
        print "<DL>\n";
        print "<DT><A NAME=\"folders\"><FONT COLOR=red><B>ߋ̃tH_ꗗ</B></FONT></A>\n";
        print "<DD>\n";
        foreach $dir (@dirs) {
            print "<A HREF=\"wwwlng.cgi?dir+$dir\">[$dir]</A>\n";
        }
        print "</DT>\n";
        print "</DL>\n";
    }

    # tb^
    &printFooter();
}

#
# gsbNꗗ
#
sub showDirPage #($dir)
{
    local($dir) = @_;
    local($file, @files);

    if (($dir !~ /^[\w\/\.]+$/) || ($dir =~ /\.\./) || ($dir =~ /^\//)) {
        &showErrorPage("̃tH_QƂ邱Ƃ͂ł܂B");
        exit(0);
    }

    &printHeader("EW(tH_$dir̃gsbNꗗ)");

    print "<A HREF=\"wwwlng.cgi\">[߂]</A>\n";
    print "<HR>\n";

    # t@C̓tƃt@C̈ꗗ𓾂
    if (!opendir(DIR, $dir)) {
        &showErrorPage("tH_邱Ƃł܂łB");
        exit(0);
    }
    while ($file = readdir(DIR)) {
        if ($file =~ /^\./) { next; }
        push(@files, (stat("$dir/$file"))[9] . " $dir/$file");
    }
    closedir(DIR);

    # tH_̃t@Cꗗ
    &printTopicList(@files);

    # tb^\
    print "<P>\n";
    &printFooter();
}

#
# gsbNꗗy[W
#
sub showTopicListByDays #($days, $unsolved)
{
    local($days, $unsolved) = @_;
    local($limittime, $mtime);
    local($dir, @dirs, $file, @files);
    local($year, $mday, $mon, $hour, $min, $sec, $timestr);

    &printHeader("EW(ߋ$daysꗗ\\)");
    print "<A HREF=\"wwwlng.cgi\">[߂]</A>\n";
    print "<HR>\n";

    # ̂݃tOݒ肷
     if ($unsolved eq "unsolved") {
         $g_unsolved = 1;
     }

    # ߋñgsbNꗗ𓾂
    $limittime = time() - ($days * 3600 * 24);
    if (!opendir(DIR, ".")) {
        &showErrorPage("tH_̎擾Ɏs܂B");
        exit(0);
    }
    while ($dir = readdir(DIR)) {
        if ($dir =~ /^\./) { next; }
        if (! -d $dir) { next; }
        push(@dirs, $dir);
        opendir(DIR2, $dir) || next;
        while ($file = readdir(DIR2)) {
            if ($file =~ /^\./) { next; }
            if (! -f "$dir/$file") { next; }
            $mtime = (stat("$dir/$file"))[9];
            ($sec, $min, $hour, $mday, $mon, $year) = localtime($mtime);
            if ($mtime >= $limittime) {
                $timestr = sprintf("%04d%02d%02d%02d%02d%02d",
                        $year + 1900, $mon + 1, $mday, $hour, $min, $sec);
                push(@files, "$timestr $dir/$file");
            }
        }
        closedir(DIR2);
    }
    closedir(DIR);
    @files = sort { $b <=> $a } @files;

    # gsbN̒g\
    &printTopicList(@files);

    &printFooter();
}

#
# gsbN\y[W
#
sub showTopicPage #($file)
{
    local($file) = @_;

    if (($file !~ /^[\w\/\.]+$/) || ($file =~ /\.\./) || ($file =~ /^\//)) {
        &showErrorPage("t@CsłB");
        exit(0);
    }

    if (!open(IN, $file)) {
        &showErrorPage("t@C($file)ǂݎ܂B");
        exit(0);
    }
    $subject = <IN>;
    $subject =~ s/^Subject: //;
    $subject =~ s/[\r\n]+$//;
    &printHeader($subject);
    print "<A HREF=\"wwwlng.cgi\">[߂]</A>\n";
    &printTopicContent(*IN);
    close(IN);

    print "<HR>\n";
    print "<FONT COLOR=red><B>ǉ</B></FONT>\n";
    print "<FORM METHOD=POST ACTION=\"wwwlng.cgi?append+$file\">\n";
    print "<NOBR>\n";
    print " O(yl[)<BR>\n";
    print "@@<INPUT TYPE=text SIZE=50 NAME=\"NAME\"><BR>\n";
    print " [AhX(ȗApœ)<BR>\n";
    print "@@<INPUT TYPE=text SIZE=50 NAME=\"EMAIL\"><BR>\n";
    print " z[y[WAhX(ȗApœ)<BR>\n";
    print "@@<INPUT TYPE=text SIZE=50 NAME=\"HPAGE\"><BR>\n";
    print " (G[đM֎~)<BR>\n";
    print "@@<INPUT TYPE=checkbox NAME=\"SOLVED\">";
    print "͎Җ{l`FbNĂB<BR>\n";
    print "@@<TEXTAREA ROWS=5 COLS=60 NAME=\"MESSAGE\"></TEXTAREA><BR>\n";
    print "@@<INPUT TYPE=submit VALUE=\" M \">\n";
    print "<INPUT TYPE=reset VALUE=\"  \">\n";
    print "</NOBR>\n";
    print "</FORM>\n";
    &printFooter();
}

#
# S\y[W
#
sub showLatelyPage #($days, $unsolved)
{
    local($days) = @_;
    local($limittime, $mtime);
    local($dir, @dirs, $file, @files);
    local($year, $mday, $mon, $hour, $min, $sec, $timestr);

    &printHeader("EW(S\\)");
    print "<A HREF=\"wwwlng.cgi\">[߂]</A>\n";

    # ߋñgsbNꗗ𓾂
    $limittime = time() - ($days * 3600 * 24);
    if (!opendir(DIR, ".")) {
        &showErrorPage("tH_̎擾Ɏs܂B");
        exit(0);
    }
    while ($dir = readdir(DIR)) {
        if ($dir =~ /^\./) { next; }
        if (! -d $dir) { next; }
        push(@dirs, $dir);
        opendir(DIR2, $dir) || next;
        while ($file = readdir(DIR2)) {
            if ($file =~ /^\./) { next; }
            if (! -f "$dir/$file") { next; }
            $mtime = (stat("$dir/$file"))[9];
            ($sec, $min, $hour, $mday, $mon, $year) = localtime($mtime);
            if ($mtime >= $limittime) {
                $timestr = sprintf("%04d%02d%02d%02d%02d%02d",
                        $year + 1900, $mon + 1, $mday, $hour, $min, $sec);
                push(@files, "$timestr $dir/$file");
            }
        }
        closedir(DIR2);
    }
    closedir(DIR);
    @files = sort { $b <=> $a } @files;

    # gsbN̒g\
    foreach $file (@files) {
        $file = (split(/ /, $file))[1];
        if (!open(IN, $file)) {
            next;
        }
        $subject = <IN>;
        $subject =~ s/^Subject: //;
        $subject =~ s/[\r\n]+$//;
        $hflag = 0;
        print "<HR>\n";
        print "<H4><FONT COLOR=green> $subject</FONT></H4>\n";
        &printTopicContent(*IN);
        print "<HR>\n";
        print "<A HREF='wwwlng.cgi?print+$file'>[()gsbNɒǉ]</A>\n";
        close(IN);
    }

    &printFooter();
}

#
# VKgsbN̓y[W
#
sub showNewTopicPage
{
    &printHeader("EW(VK)");

    print "<A HREF=\"wwwlng.cgi\">[߂]</A>\n";
    print "<HR>\n";
    print "<FORM METHOD=POST ACTION=\"wwwlng.cgi?new2\">\n";
    print " ^Cg<BR>\n";
    print "@@Eu`ɂ́Hv̂悤Ȏ`ɂĂB<BR>\n";
    print "@@Eu`ɂāv̌`͍D܂܂B<BR>\n";
    print "@@<INPUT TYPE=text SIZE=50 NAME=\"SUBJECT\"><BR>\n";
    print "<P> O<BR>\n";
    print "@@Eyl[ł܂܂B<BR>\n";
    print "@@<INPUT TYPE=text SIZE=50 NAME=\"NAME\"><BR>\n";
    print "<P> [AhX<BR>\n";
    print "@@EFfoo\@www.xxx.zzz<BR>\n";
    print "@@Epœ͂ĂB<BR>\n";
    print "@@E󗓂ł܂܂B<BR>\n";
    print "@@<INPUT TYPE=text SIZE=50 NAME=\"EMAIL\"><BR>\n";
    if (-x $g_sendmail) {
        print "@@񓚂[ŎM܂H\n";
        print "<INPUT TYPE=radio NAME=\"REPLY\" VALUE=\"on\" CHECKED>͂\n";
        print "<INPUT TYPE=radio NAME=\"REPLY\" VALUE=\"\"><BR>\n";
    }
    print "<P> z[y[WAhX<BR>\n";
    print "@@EFhttp://www.xxx.zzz/<BR>\n";
    print "@@Epœ͂ĂB<BR>\n";
    print "@@E󗓂ł܂܂B<BR>\n";
    print "@@<INPUT TYPE=text SIZE=50 NAME=\"HPAGE\"><BR>\n";
    print "<P> e<BR>\n";
    print "@@Ez[y[W쐬Ɋւ鎿ȊO͂B<BR>\n";
    print "@@E܂蒷ɂȂȂ悤ɂĂB<BR>\n";
    print "@@EG[AđMƓdMɂȂ邱Ƃ܂B<BR>\n";
    print "@@E񓚂ꂽA珑ݎ[]`FbNĂB<BR>\n";
    print "@@<TEXTAREA ROWS=5 COLS=60 NAME=\"MESSAGE\"></TEXTAREA><BR>\n";
    print "<P>\n";
    print "@@<INPUT TYPE=submit VALUE=\" M \">\n";
    print "<INPUT TYPE=reset VALUE=\"  \">\n";
    print "</FORM>\n";
    &printFooter();
}

#
# y[W
#
sub showSearchPage
{
    # o͎Ƀobt@OȂ悤ɂ
    $| = 1;

    &printHeader("EW()");
    print "<A HREF=\"wwwlng.cgi\">[߂]</A>\n";
    print "<HR>\n";

    # L[[hΏI
    if (!$FORM{'WORD'}) {
        goto done;
    }

    # ̃[h𕪊
    @words = split(/ +/, $FORM{'WORD'});

    # ^𖳌
    for ($i = 0; $i <= $#words; $i++) {
        $words[$i] =~ s/([\+\*\.\?\^\$\[\-\]\|\(\)\\])/\\$1/g;
    }

    # L[[hMO
    if (-f $g_search_log) {
        if (open(OUT, ">> $g_search_log")) {
            for ($i = 0; $i <= $#words; $i++) {
                print OUT "$words[$i]\n";
            }
            close(OUT);
        }
    }

    # fBNg̈ꗗ𓾂
    @dirs = ();
    if (!opendir(DIR, ".")) {
        &showErrorPage("tH_̎擾Ɏs܂B");
        exit(0);
    }
    while ($dir = readdir(DIR)) {
        if ($dir =~ /^\./) { next; }
        if (! -d $dir) { next; }
        push(@dirs, $dir);
    }
    closedir(DIR);

    print "<DL>\n";
    foreach $dir (@dirs) {
        if (!opendir(DIR, $dir)) {
            next;
        }
        while ($file = readdir(DIR)) {
            if ($file =~ /^\./) { next; }
            if (! -f "$dir/$file") { next; }
            &printSearchResult("$dir/$file", @words);
        }
        closedir(DIR);
    }
    print "</DL>\n";

  done:
    &printFooter();
}

#
# Ȑffy[W
#
sub showTestPage
{
    &printHeader("EW(Ȑff)");
    print "<A HREF=\"wwwlng.cgi\">[߂]</A>\n";
    print "<HR>\n";
    print "OK. CGI͐ɓ삵Ă܂B<BR>\n";
    if (!-x $g_sendmail) {
        print "NG. $g_sendmail܂B<BR>\n";
    }
    if (!-d $g_lockdir) {
        print "NG. $g_lockdir܂B<BR>\n";
    }
    if (-d $g_lockfile) {
        print "NG. $g_lockfilecĂ܂B폜ĂB<BR>\n";
    }
    &printFooter();
}

#
# G[y[W
#
sub showErrorPage #($errmsg)
{
    local($errmsg) = @_;

    &printHeader("EW(G[)");
    print "<A HREF=\"wwwlng.cgi\">[߂]</A>\n";
    print "<HR>\n";
    print $errmsg;
    &printFooter();
}

#
# gsbNǉ
#
sub appendTopic
{
    # ̓p[^̃`FbN
    if ($FORM{'SUBJECT'} =~ /^[ @\r\n]*$/) {
        &showErrorPage("^Cg͂Ă܂B");
        exit(0);
    }
    if ($FORM{'SUBJECT'} =~ /[\r\n]/) {		# ZLeBΉ
        &showErrorPage("^Cgɉs܂߂邱Ƃ͂ł܂B");
        exit(0);
    }
    if ($FORM{'NAME'} =~ /^[ @\r\n]*$/) {
        &showErrorPage("O͂Ă܂B");
        exit(0);
    }
    if ($FORM{'MESSAGE'} =~ /^[ @\r\n]*$/) {
        &showErrorPage("e͂Ă܂B");
        exit(0);
    }
    if ($FORM{'EMAIL'} && ($FORM{'EMAIL'} !~ /^[\.\-\w]+@[\.\-\w]+$/)) {
        &showErrorPage("[AhX̌`słB");
        exit(0);
    }

    # bN
    if (!&fileLock()) {
        &showErrorPage("t@C̃bNɎs܂B");
        exit(0);
    }

    # gpĂȂt@CT
    if (!($file = &determineFileName())) {
        &showErrorPage("VK݂̏Ɏs܂B");
        goto done;
    }

    # TuWFNg
    if (!open(OUT, "> $file")) {
        &showErrorPage("VK݂̏Ɏs܂B");
        goto done;
    }
    print OUT "Subject: $FORM{'SUBJECT'}\n";
    if (($FORM{'REPLY'} eq "on") && $FORM{'EMAIL'}) {
        print OUT "Reply-To: $FORM{'EMAIL'}\n";
    }
    close(OUT);

    # bZ[Wǉ
    &appendMessage($file, 0);

  done:
    &fileUnlock();
}

#
# ǉ
#
sub appendMessage #($file, $lockflag)
{
    local($file, $lockflag) = @_;

    if (($file !~ /^[\w\/\.]+$/) || ($file =~ /\.\./) || ($file =~ /^\//)) {
        &showErrorPage("t@CsłB");
        exit(0);
    }

    # ̓p[^̃`FbN
    if ($FORM{'NAME'} =~ /^[ @\r\n]*$/) {
        &showErrorPage("O͂Ă܂B");
        exit(0);
    }
    if ($FORM{'MESSAGE'} =~ /^[ @\r\n]*$/) {
        &showErrorPage("e͂Ă܂B");
        exit(0);
    }

    # bN
    if ($lockflag) {
        if (!&fileLock()) {
            &showErrorPage("t@C̃bNɎs܂B");
            exit(0);
        }
    }

    # gsbNɔǉ
    $msg = "========================================\n";
    $msg .= "From: $FORM{'NAME'}\n";
    if ($FORM{'EMAIL'} ne "") {
        $FORM{'EMAIL'} =~ s/'//g;
        $msg .= "E-Mail: $FORM{'EMAIL'}\n";
    }
    if ($FORM{'HPAGE'} ne "") {
        $FORM{'HPAGE'} =~ s/'//g;
        $msg .= "HomePage: $FORM{'HPAGE'}\n";
    }
    ($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime();
    $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d:%02d",
        $year + 1900, $mon + 1, $mday, $g_wdays[$wday], $hour, $min, $sec);
    $msg .= "Date: $date\n";
    if ($FORM{'SOLVED'} eq "on") {
        $msg .= "Solved: $FORM{'SOLVED'}\n";
    }
    $msg .= "\n";
    $msg .= "$FORM{'MESSAGE'}\n";
    if (!open(OUT, ">> $file")) {
        &showErrorPage("$fileւ݂̏Ɏs܂B");
        exit(0);
    }
    $old = select(OUT); $| = 1; select($old);
    print OUT $msg;
    close(OUT);

    # ҂Ƀ[Œm点
    $mailto = "";
    open(IN, "$file");
    while (<IN>) {
        if (/^Reply-To:/) {
            chop($_);
            $mailto = $_;
            $mailto =~ s/^Reply-To: //;
        }
        if (/^\t/) {
            last;
        }
    }
    if ($mailto ne "") {
        seek(IN, 0, 0);
        $msg = "To: $mailto\n";
        $msg .= "Subject: TwnLounge Report\n";
        $msg .= "\n";
        while (<IN>) {
            $_ =~ s/[\r\n]*$//;
            $_ =~ s/^\.$/. /;
            $_ =~ s/&lt;/</g;
            $_ =~ s/&gt;/>/g;
            $_ =~ s/&amp;/&/g;
            $msg .= "$_\n";
        }
        &jcode'convert(*msg, "jis");
        open(OUT, "| $g_sendmail $mailto");
        print OUT $msg;
        close(OUT);
    }
    close(IN);

    # bN͂
    if ($lockflag) {
        &fileUnlock();
    }

  done:
    # y[W\
    print "Location: http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}?print+$file\n\n";
    # &showTopicPage($file);

    return(1);
}

#
# VKt@C肷
#
sub determineFileName
{
    local($sec, $min, $hour, $mday, $mon, $year);
    local($dir, @files, $file, $num);

    # fBNg(YYYYMM)𓾂
    ($sec, $min, $hour, $mday, $mon, $year) = localtime();
    $dir = sprintf("%04d%02d", $year + 1900, $mon + 1);

    # fBNg΍쐬
    if (!-d $dir) {
        mkdir($dir, 0755);
    }

    # ŐṼt@Cԍ𓾂
    $num = 0;
    opendir(DIR, $dir);
    foreach $file (readdir(DIR)) {
        if ($file =~ /^[0-9]{4}([0-9]{4}).txt$/) {
            $num = ($num < $1) ? $1 : $num;
        }
    }
    closedir(DIR);
    $num++;

    # t@C(YYYYMM/YYMMNNNN.txt)Ԃ
    return(sprintf("$dir/%02d%02d%04d.txt", $year % 100, $mon + 1, $num));
}

#
# gsbN폜
#
sub deleteTopic #($passwd, $file)
{
    local($passwd, $file) = @_;

    # pX[h`FbN
    if (($g_passwd eq "") || ($passwd ne $g_passwd)) {
        &showErrorPage("pX[hႢ܂B");
        exit(0);
    }

    if ($file =~ /(^\/|\.\.)/) {
        &showErrorPage("̃tH_̃t@C폜邱Ƃ͂ł܂B");
        exit(0);
    }

    if (!unlink($file)) {
        &showErrorPage("$file̍폜Ɏs܂B");
        exit(0);
    }

    &printHeader("EW(폜)");
    print "<A HREF=\"wwwlng.cgi\">[߂]</A>\n";
    print "<HR>\n";
    print "$file ̍폜܂B\n";
    &printFooter();
}

#
# t@C̍XV킹
#
sub utimeTopic #($passwd, @dirs)
{
    local($passwd, @dirs) = @_;
    local($dir);

    # pX[h`FbN
    if (($g_passwd eq "") || ($passwd ne $g_passwd)) {
        &showErrorPage("pX[hႢ܂B");
        exit(0);
    }

    foreach $dir (@dirs) {
        if ($dir =~ /(^\/|\.\.)/) {
            &showErrorPage("̃tH_QƂ邱Ƃ͂ł܂B");
            exit(0);
        }
    }

    &printHeader("EW(ǗҗpFt@C̎)");
    print "<A HREF=\"wwwlng.cgi\">[߂]</A>\n";
    print "<HR>\n";

    if ($dirs[0] eq "all") {
        @dirs = ();
        if (!opendir(DIR, ".")) {
            &showErrorPage("tH_̎擾Ɏs܂B");
            exit(0);
        }
        while ($dir = readdir(DIR)) {
            if ($dir =~ /^\./) { next; }
            if (! -d $dir) { next; }
            push(@dirs, $dir);
        }
        closedir(DIR);
    }

    foreach $dir (@dirs) {
        if (!opendir(DIR, $dir)) {
            next;
        }
        while ($file = readdir(DIR)) {
            if ($file =~ /^\./) { next; }
            if (! -f "$dir/$file") { next; }
            $file = "$dir/$file";
            $date = "";
            if (!open(IN, $file)) {
                next;
            }
            while (<IN>) {
                if (/^========================================[\r\n]+$/) {
                    $hflag = 1;
                }
                if (/^[\r\n]+$/) {
                    $hflag = 0;
                }
                if ($hflag == 0) {
                    next;
                }
                if (/^Date: /) {
                    $date = $_;
                }
            }
            close(IN);
            if ($date =~ /(\d\d\d\d)\/(\d\d)\/(\d\d).*(\d\d):(\d\d):(\d\d)/) {
                $mtime = &mktime($1 - 1900, $2 - 1, $3, $4, $5, $6, -9);
                if (utime($mtime, $mtime, $file)) {
                    print "$file $date OK.<BR>\n";
                } else {
                    print "$file $date NG.<BR>\n";
                }
                #$mtime = sprintf("%02d%02d%02d%02d%02d.%02d",
                #    $2, $3, $4, $5, $1 - 1900, $6);
                #print("/bin/touch -t $mtime $file<BR>\n");
                #print system("/bin/touch -t $mtime $file");
                #print "<BR>\n";
            }
        }
    }

    &printFooter();
}

#
# wb_o
#
sub printHeader #($title)
{
    local($title) = @_;

    print "Content-type: text/html\n";
    print "\n";
    print "<HTML>\n";
    print "<HEAD>\n";
    print "<TITLE>$title</TITLE>\n";
    print "</HEAD>\n";
    print "<BODY TEXT=black BGCOLOR=white>\n";
    print "<H2>$title</H2>\n";
}

#
# tb^o
#
sub printFooter
{
    print "<HR>\n";
    print "<DIV ALIGN=right>\n";
    print "<I><FONT FACE=\"Courier\">$g_name</FONT></I>\n";
    print "</DIV>\n";
    print "</BODY>\n";
    print "</HTML>\n";
}

#
# gsbNꗗo
#
sub printTopicList #(@files)
{
    local(@files) = @_;
    local($file, $hflag, $count, $questioner, $solved, $from, $date, $subject);
    local($line);

    print "<SCRIPT><!--\n";
    print "function func() {\n";
    print "  cbs = document.getElementsByClassName('chk');\n";
    print "  for (i = 0; i < cbs.length; i++) {\n";
    print "    if (cbs[i].checked) {\n";
    print "      win = window.open('wwwlng.cgi?print+' + cbs[i].name, '_blank');\n";
    print "      cbs[i].checked = false;\n";
    print "    }\n";
    print "  }\n";
    print "}\n";
    print "function func2(form, action) {\n";
    print "  var unsolved = form.unsolved.checked ? '+unsolved' : '';\n";
    print "  window.open('wwwlng.cgi?' + action + '+' + form.t1.value + unsolved, '" . $g_target . "');\n";
    print "}\n";
    print "// --></SCRIPT>\n";
    print "<FORM METHOD=POST NAME=\"f1\" TARGET=\"" . $g_target . "\" ACTION=\"wwwlng.cgi?search\">\n";
    print "<UL>\n";
    print "<LI>EW̑SgsbNP ";
    print "<INPUT TYPE=text SIZE=10 NAME=\"WORD\"> ";
    print " <INPUT TYPE=submit VALUE=\"\">\n";
    print "<LI>̃gsbN\n";
    print "<INPUT TYPE=button onClick='func()' VALUE=\"S\\\">\n";
    print "<LI>ߋ <INPUT TYPE=text NAME=\"t1\" SIZE=3 VALUE=3>\n";
    print "̃gsbN\n";
    print "<INPUT TYPE=button VALUE=\"ꗗ\\\" ";
    print "onClick=\"func2(this.form, 'list')\"> / \n";
    print "<INPUT TYPE=button VALUE=\"S\\\" ";
    print "onClick=\"func2(this.form, 'showall')\"><BR>\n";
    print "<INPUT TYPE=\"checkbox\" NAME=\"unsolved\" VALUE=\"unsolved\"";
    if ($g_unsolved) {
        print " CHECKED";
    }
    print "> ̃gsbN݈̂ꗗ\\\n";
    print "</UL>\n";
    print "<TABLE BORDER=1>\n";
    print "<TR>\n";
    print "<TH></TH>\n";
    print "<TH>ŏI<BR>XV</TH>\n";
    if ($g_show_questioner) {
        print "<TH><FONT COLOR=red></FONT></TH>\n";
    }
    print "<TH><FONT COLOR=red>ŏI<BR></FONT></TH>\n";
    print "<TH><BR></TH>\n";
    print "<TH>^Cg</TH>\n";
    print "</TR>\n";
    $line = 0;
    foreach $file (@files) {
        $file = (split(/ /, $file))[1];
        open(IN, $file) || next;
        $hflag = 0;
        $count = 0;
        $questioner = "";
        $solved = "@";
        $from = "@";
        $date = "@";
        $subject = <IN>;
        $subject =~ s/^Subject: //;
        $subject =~ s/[\r\n]+$//;
        while (<IN>) {
            if (/^========================================[\r\n]+$/) {
                $hflag = 1;
            }
            if (/^[\r\n]+$/) {
                $hflag = 0;
            }
            if ($hflag == 0) {
                next;
            }
            if (/^From: (.*)[\r\n]+$/) {
                $from = $1;
                if (!$questioner) {
                    $questioner = $from;
                }
                $count++;
            }
            if (/^Solved:/) {
                $solved = "";
            }
            if (/^Date: (\d+)\/(\d+)\/(\d+)/) {
                $date = "$1/$2/$3";
            }
        }
        if (($g_unsolved == 0) or ($solved eq "@")) {
            print "<TR>\n";
            print "<TD><INPUT TYPE=checkbox NAME='$file' CLASS='chk'></TD>\n";
            print "<TD>$date</TD>\n";
            if ($g_show_questioner) {
                print "<TD><FONT COLOR=red>$questioner</FONT></TD>\n";
            }
            print "<TD><FONT COLOR=red>$from</FONT></TD>\n";
            print "<TD>$solved</TD>\n";
            print "<TD><A HREF=\"wwwlng.cgi?print+$file\" TITLE=\"$file\">";
            print "$subject</A>($count)</TD>\n";
            print "</TR>\n";
        }
        close(IN);
        if ((++$line % 10) == 0) {
            print "</TABLE>\n";
            print "<P>\n";
            print "<TABLE BORDER=1>\n";
        }
    }
    print "</TABLE>\n";
    print "</FORM>\n";
}

#
# gsbNeo
#
sub printTopicContent #(IN)
{
    local(*IN) = @_;

    while (<IN>) {
        s/[\r\n]+//;
        if (/^Reply-To: /) {
            next;
        } elsif ($hflag && /^From: /) {
            s/^From: //;
            print "<HR>\n";
            print "<FONT COLOR=red><B>$_</B></FONT>\n";
        } elsif ($hflag && /^E-Mail: /) {
            s/^E-Mail: //;
            print "<A HREF='mailto:$_'>[E-Mail]</A>\n";
        } elsif ($hflag && /^HomePage: /) {
            s/^HomePage: //;
            print "<A HREF='$_'>[HomePage]</A>\n";
        } elsif ($hflag && /^Date: /) {
            s/^Date: //;
            print "$_<BR>\n";
        } elsif ($hflag && /^Solved: /) {
            print "[[<FONT COLOR='#008080'></FONT>]]<BR>\n";
        } elsif (/^========================================[\r\n]*$/) {
            $hflag = 1;
        } elsif ($hflag && ($_ eq "")) {
            $hflag = 0;
        } else {
            s/(http:\/\/[a-zA-Z0-9\.\/\-+#_?~&%=^\@:;]+)/<A HREF="$1">$1<\/A>/g;
            s/^((&gt;|).*$)/<FONT COLOR="#CC8000">$1<\/FONT>/;
            print "$_<BR>\n";
        }
    }
}

#
# ʂo
#
sub printSearchResult #($file)
{
    local($file, @words) = @_;
    local($subject, $wcount, $word);
    local(%wordflag, %wordtext);

    $title = "";
    $wcount = 0;
    open(IN, $file);
    $subject = <IN>;
    $subject =~ s/^Subject: //;
    $subject =~ s/[\r\n]+$//;
    seek(IN, 0, 0);
    loop: while (<IN>) {
        foreach $word (@words) {
            if ($wordflag{$word} == 1) { next; }
            if (!/$word/) { next; }
            s/[\r\n]+$//;
            $wordtext{$word} = $_;
            $wordflag{$word} = 1;
            if (($FORM{'ANDOR'} eq "or") || (++$wcount == $#words + 1)) {
                if ($subject eq "") { $subject = $file; }
                print "<P>\n";
                print "<DT><A HREF='wwwlng.cgi?print+$file'>$subject</A>\n";
                foreach $word (@words) {
                    print "<DD>$wordtext{$word}\n";
                }
                last loop;
            }
        }
    }
    close(IN);
}

#
# tH[f[^ǂ݂
#
sub readParam
{
    local($query_string, @a, $x, $name, $value);

    if ($ENV{'REQUEST_METHOD'} ne "POST") {
        return(1);
    }
    if (!read(STDIN, $query_string, $ENV{'CONTENT_LENGTH'})) {
        return(undef);
    }
    @a = split(/&/, $query_string);
    foreach $x (@a) {
        ($name, $value) = split(/=/, $x);
        $value =~ tr/+/ /;
        $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
        &jcode'convert(*value, "euc");
        &jcode'h2z_euc(*value);
        $value =~ s/&/&amp;/g;
        $value =~ s/</&lt;/g;
        $value =~ s/>/&gt;/g;
        $value =~ s/\r\n/\n/g;
        $value =~ s/\s+$//;
        &jcode'convert(*value, "sjis", "euc");
        $FORM{$name} = $value;
    }
    return(1);
}

#
# t@CbN
#
sub fileLock
{
    for ($i = 1; $i <= 6; $i++) {
        if (mkdir($g_lockfile, 0755)) {
            $SIG{'PIPE'} = "sigexit";
            $SIG{'INT'} = "sigexit";
            $SIG{'HUP'} = "sigexit";
            $SIG{'QUIT'} = "sigexit";
            $SIG{'TERM'} = "sigexit";
            last;
        } elsif ($i < 6) {
            sleep(2);
        } else {
            return(undef);
        }
    }
    return(1);
}

#
# t@C̃bN
#
sub fileUnlock
{
    for ($i = 1; $i <= 4; $i++) {
        if (rmdir($g_lockfile) == 0) {
            last;
        } elsif ($i < 4) {
            sleep(1);
        } else {
            return(undef);
        }
    }
    return(1);
}

#
# vOf̏
#
sub sigexit
{
    if (-d $g_lockfile) {
        rmdir($g_lockfile);
    }
    exit(0);
}

#
# N// ::bAUNIX(1970/1/1̕b)߂
#
sub mktime #($year, $mon, $mday, $hour, $min, $sec, $tz)
{
    local($year, $mon, $mday, $hour, $min, $sec, $tz) = @_;
    local(@mdays, $xtime);

    @mdays = ( 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334);
    $uru = int(($year - 72) / 4);
    if (((($year + 1900) % 4) == 0) && ($mon < 2)) { $uru--; }
    $xtime = $year - 70;
    $xtime = ($xtime * 365) + $mdays[$mon] + $mday + $uru;
    $xtime = ($xtime * 24) + $hour + $tz;
    $xtime = ($xtime * 60) + $min;
    $xtime = ($xtime * 60) + $sec;
    return($xtime);
}

